﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace AutoFolderMirror
{
    public partial class DirUserControl : UserControl
    {
        public DirUserControl()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 粘贴时自动清空的数据
        /// </summary>
        public string ClipReplace { get; set; } = "";

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.txt_dir.Text != "")
            {
                Directory.CreateDirectory(this.txt_dir.Text);
                return;
            }
            MessageBox.Show("请输入目录结构！", "警告", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btn_MkDir_Click(object sender, EventArgs e)
        {
            if (System.IO.Directory.Exists(this.txt_dir.Text))
            {
                System.Diagnostics.Process.Start("explorer", "/select," + this.txt_dir.Text);
            }
            else
            {
                MessageBox.Show("找不到文件夹。");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            button1_Click(sender, e);
            btn_MkDir_Click(sender, e);
        }

        private void txt_dir_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            // Declares an IDataObject to hold the data returned from the clipboard.
            // Retrieves the data from the clipboard.
            IDataObject iData = Clipboard.GetDataObject();
            
            // Determines whether the data is in a format you can use.
            if (iData.GetDataPresent(DataFormats.Text))
            {
                // Yes it is, so display it in a text box.
                string ClipText = ((String)iData.GetData(DataFormats.Text));
                if (!string.IsNullOrEmpty(ClipText))
                {
                    if (string.IsNullOrEmpty(ClipReplace))
                    {
                        txt_dir.Text = ClipText;
                    }
                    else
                    {
                        txt_dir.Text = ClipText.Replace(ClipReplace, "");
                    }
                }
            }
        }
    }
}
