﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.IO;
using System.Threading;

namespace AutoFolderMirror
{
    public partial class MainForm : Form
    {
        MirrorInfo mirrorinfo = new MirrorInfo();

        public MainForm()
        {
            InitializeComponent();
        }

        public void alert(string text)
        {
            MessageBox.Show(text);
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            Form.CheckForIllegalCrossThreadCalls = false;
        }
        #region Form1拖放
        private void Form1_DragDrop(object sender, DragEventArgs e)
        {
            string path = ((System.Array)e.Data.GetData(DataFormats.FileDrop)).GetValue(0).ToString();

            if (Directory.Exists(path))
            {
                textBox1.Text = path;
                return;
            }
            if (File.Exists(path))
            {
                FileInfo fi = new FileInfo(path);
                textBox1.Text = fi.DirectoryName;
                return;
            }
        }

        private void Form1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Link;
            else
                e.Effect = DragDropEffects.None;
        }
        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            this.Text = "开始";
            string sdirpath = textBox1.Text.Trim();
            if (!Directory.Exists(sdirpath))
            {
                alert("目录不存在");
                return;
            }
            mirrorinfo.SourceDirPath = sdirpath;
            #region 确定哪种模式
            if (rdbtnAllMirrirPath.Checked == true)
            {
                mirrorinfo.IsCopyContent = false;
            }
            if (radioButton1.Checked == true)
            {
                mirrorinfo.IsCopyContent = false;
                mirrorinfo.IsNoFile = false;
            }
            if (rdbtnMirrorExcept.Checked == true)
            {
                mirrorinfo.IsCopyContent = true;
                string fb = txtFileBytes.Text.Trim();
                int criticalFileBytes;
                try
                {
                    criticalFileBytes = Math.Max(1024, Int32.Parse(fb) * 1024);
                }
                catch
                {
                    criticalFileBytes = 1 * 1024;
                }
                mirrorinfo.CriticalFileBytes = criticalFileBytes;
            }
            #endregion
            Thread t = new Thread(MirrorWork);
            t.IsBackground = true;
            t.Start();
        }

        private void MirrorWork()
        {
            try
            {
                panel1.Enabled = false;
                mirrorinfo.Mirror();
                this.Text = "镜像完毕 + " + DateTime.Now.ToLongTimeString();
            }
            catch (Exception e)
            {
                this.Text = e.Message;
            }
            finally
            {
                panel1.Enabled = true;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            dirUserControl1.ClipReplace = textBox2.Text;
        }

        public void MouseDoubleClick()
        {
            // Declares an IDataObject to hold the data returned from the clipboard.
            // Retrieves the data from the clipboard.
            IDataObject iData = Clipboard.GetDataObject();

            // Determines whether the data is in a format you can use.
            if (iData.GetDataPresent(DataFormats.Text))
            {
                // Yes it is, so display it in a text box.
                string ClipText = ((String)iData.GetData(DataFormats.Text));
                if (!string.IsNullOrEmpty(ClipText))
                {
                    textBox2.Text = ClipText;
                }
            }
        }
        private void textBox2_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            MouseDoubleClick();
        }

        private void dirUserControl1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            MouseDoubleClick();
        }

        private void dirUserControl1_Load(object sender, EventArgs e)
        {

        }
    }
}
